#!/usr/bin/env python3
# -*- coding: utf-8 -*-

#
# (c) Simon Psenner, iteas IT Services GmbH
# simon.psenner@iteas.at
# www.iteas.at
#
import json
import os
import subprocess

from flask import Flask, jsonify, request
from flask_restful import reqparse, abort, Api, Resource

app = Flask(__name__)
api = Api(app)


@app.route('/')
def index():
    return "Hello World!"


# Todo How to deal with multiple Printjobs at a time

class PrintAroma(Resource):
    def post(self):
        data = request.data
        json_data = json.loads(str(data.decode("utf-8")))

        with open('/var/lib/printserver-templates/aroma19.zpl', 'r') as myfile:
            data = myfile.read()

        barcode = json_data.get("barcode", "")  # 30000118777000050102040
        country = json_data.get("country", "")  # AT
        lotnumber = json_data.get("lotnumber", "")  # 1877700005
        suppliernumber = json_data.get("supplier", "")  # 300001
        ggnr = json_data.get("ggnr", "")  # Zertifikatsnumber
        suppliername = json_data.get("suppliername", "")  # Franz Huber
        prodnr = json_data.get("prodnr", "")  # 102
        prodname = json_data.get("prodname", "")  # Idared

        farmnr = json_data.get("farmnr", "")  # 2548
        farmname = json_data.get("farmname", "")  # Anlage B45

        amount = json_data.get("amount", "")  # 40
        container = json_data.get("container", "")  # GKP

        certs = json_data.get("certs", "")  # GGAP
        lsnr = json_data.get("lsnr", "")  # Lieferscheinnumber
        year = json_data.get("year", "")  # 2019
        deliverydate = json_data.get("deliverydate", "")  # 02.11.2017

        pages = json_data.get("pages", "3")  # 2

        with open("/tmp/aromaout.zpl", "w+") as file:
            file.write(data % (
            barcode, country, lotnumber, suppliernumber, ggnr, suppliername, prodnr, prodname, farmnr, farmname, amount,
            container, certs, lsnr, year, deliverydate, pages))

        subprocess.call(["lpr -PZebra_ZD420 -o raw /tmp/aromaout.zpl"], shell=True)
        # count = 0
        # while count < pages:
        #    count += 1
        #    print("printing")
        #    subprocess.call(["lpr -PZebra_ZD420 -o raw /tmp/aromaout.zpl"], shell=True)

        return jsonify(message="Printjob Recived")


class PrintMeleco(Resource):
    def post(self):
        data = request.data
        json_data = json.loads(str(data.decode("utf-8")))

        with open('/var/lib/printserver-templates/meleco20.zpl', 'r') as myfile:
            data = myfile.read()

        barcode = json_data.get("barcode", "")  # 30000118777000050102040
        country = json_data.get("country", "")  # AT
        lotnumber = json_data.get("lotnumber", "")  # 1877700005
        prodname = json_data.get("prodname", "")  # Idared
        amount = json_data.get("amount", "")  # 40
        container = json_data.get("container", "")  # GKP
        certtype1 = json_data.get("certtype1", "")  # Zertifikatstype
        certnr1 = json_data.get("certnr1", "")  # Zertifikatsnumber
        certtype2 = json_data.get("certtype2", "")  # Zertifikatstype
        certnr2 = json_data.get("certnr2", "")  # Zertifikatsnumber
        certtype3 = json_data.get("certtype3", "")  # Zertifikatstype
        certnr3 = json_data.get("certnr3", "")  # Zertifikatsnumber
        certtype4 = json_data.get("certtype4", "")  # Zertifikatstype
        certnr4 = json_data.get("certnr4", "")  # Zertifikatsnumber
        suppliername = json_data.get("suppliername", "")  # Franz Huber
        farmname = json_data.get("farmname", "")
        lsnr = json_data.get("lsnr", "")  # Lieferscheinnumber
        year = json_data.get("year", "")  # 2017
        deliverydate = json_data.get("deliverydate", "")  # 02.11.2017
        pages = json_data.get("pages", "3")  # 2


        with open("/tmp/melecoout.zpl", "w+") as file:
            file.write(data % (barcode, country, lotnumber, prodname, amount, container, suppliername, farmname,
                               certtype1, certnr1, certtype2, certnr2, certtype3, certnr3, certtype4, certnr4, lsnr,
                               year, deliverydate, pages))

        print("printing")
        subprocess.call(["lpr -PZebra_ZD420 -o raw /tmp/melecoout.zpl"], shell=True)


api.add_resource(PrintAroma, '/aroma')
api.add_resource(PrintMeleco, '/meleco')

if __name__ == "__main__":
    app.run(host='0.0.0.0', port=8080, debug=True)
